// Header File
// Created 29/06/2005; 16:19:49
#ifndef __HAWK_initialise_H__
#define __HAWK_initialise_H__

//==========================================================================//

#define VERSION			"version 1.00"
#define DATE				"13/09/2005"

//==========================================================================//

#define NB_COL     	(TI89 ? 7: 10)          // Adapte le nombre de colonnes dans la matrice clavier 
#define ADAPT_Y			(TI89 ? 0: 14)					// Adaptation pour centrer les messages en hauteur; 14 = (128-100)/2
#define ADAPT_X			(TI89 ? 0: 40)
  																  																		 		
//==========================================================================//
//	Modes pour la police
//==========================================================================//

#define MODE_AND								0
#define MODE_REMPLACE						1

//==========================================================================//
//	Tailles de la police
//==========================================================================//

#define PETIT										0
#define MOYEN										1
#define GROS										2

//==========================================================================//
//	Niveaux de gris
//==========================================================================//

#define GRIS_CLAIR							0
#define GRIS_FONCE  						1

//======================================================================================//
//	Rglages pour la rapidit du jeu: plus la constante est grande, plus le jeu est lent
//======================================================================================//

#define TEMPO_BORDS							1
#define TEMPO_ANIMS_STEPS				4
#define TEMPO_EXPLOSION_BOMBE		2
#define TEMPO_CLIGNO_VAISS			3
#define TEMPO_CLIGNO_DEAD				4

//=========================================================================//

#define	NB_MAX_TIRS							4										// Nombre maximal de tirs
#define NB_MAX_BOMBES						12									// Nombre maximal de bombes
#define NB_MAX_PROJ							10									// Nombre maximal de projectiles
#define NB_MAX_TROMPES					4										// Nombre maximal de trompes

//=========================================================================//
//	Animations spciales
//=========================================================================//

#define OEIL					0
#define	TIGE_NORMALE	1
#define MUR						2
#define TROMPE				3

//==========================================================================//
//	Animations normales
//=========================================================================//

#define TRITON					0
#define TOUR						1
#define BALLE						2
#define CHAUVE_SOURIS		3
#define SOLEIL					4
#define RAISIN					5
#define LAMPE						6
#define VIOLON					7
#define TELESCOPE				8
#define SERPENT					9		// tte du serpent
#define LAMPE_SYM				10	// symtrique de la lampe par rapport  la verticale

//==========================================================================//

#define SANS_PROJ				0	// Indique si une animation
#define AVEC_PROJ				1	// gnre des projectiles

//==========================================================================//
//	Constantes des bonus
//==========================================================================//

#define PULSE						0
#define SHIP_1					1
#define SHIP_2					2
#define SHIELD					3
#define SHIP_4					4
#define SHIP_3					5
#define SHIP_5					6
#define	AUTO_FIRE				7
#define SINGLE_CANON		8
#define DOUBLE_CANON		9
#define TRIPLE_CANON		10

//==========================================================================//
//	Pour tous les flags
//==========================================================================//

#define NOTHING					-1

//==========================================================================//
//	Structure des hiscores
//==========================================================================//
    
typedef struct
{
   unsigned char nom[10];	// 10 bytes
   unsigned long score;		// 4 bytes
} HIGH_SCORES;
  
HIGH_SCORES hscore[5] = {
{"----------", 5000},
{"- A GAME -", 4000},
{"PROGRAMMED", 3000},
{"- BY NUL -", 2000},
{"----------", 1000},
};	// 14*5 = 70 bytes

//==========================================================================//
																		
INT_HANDLER int1 = NULL;
INT_HANDLER int2 = NULL;
INT_HANDLER int5 = NULL;
SCR_RECT ecran = {{0, 0, 239, 127}};
unsigned char touche[10] = {}, vieille_t[10] = {};
unsigned char * Sauvegarde = NULL;	// Sert  lire
SYM_ENTRY * entry = NULL;						// le fichier externe de sauvegarde

short TEMPO_FOND = 0;
short compteur = 0;	//	Compteur global du jeu
short liste_x_bombes[NB_MAX_BOMBES] = {};	//	Listes des coordones
short liste_y_bombes[NB_MAX_BOMBES] = {};	//	des bombes gnres par le vaisseau
short liste_flags[NB_MAX_BOMBES] = {};	//	Sert pour les explosions des bombes
short last_bombe = 0;	//	Indice dans les listes de la dernire bombe lche
short liste_x_proj[NB_MAX_PROJ] = {};	//	Listes des projectiles
short liste_y_proj[NB_MAX_PROJ] = {};	//	gnrs par les animations
short liste_x_incr_proj[NB_MAX_PROJ] = {};	// Listes des incrmentations verticales et horizontales
short liste_y_incr_proj[NB_MAX_PROJ] = {};	// des projections
short last_proj = 0; //	Indice dans les listes du dernier projectile lanc
short x_oeil = 0;	//	Coordonnes
short y_oeil = 0;	//	de l'oeil
short flag_oeil = 0;	//	Sert  l'animation de l'oeil et pour lancer les projectiles
short oeil_dead = 0;	//	Compte le nombre de bombes recues par l'oeil
short flag_crash = 0;	//	Indique si le vaisseau a t touch par un bord ou une animation
short last_anim = 0;	//	Indice de l'indice de la dernire animation dans la liste 'animation'
short indice_global = 0;	//	Indice dans les listes des animations dans le header 'listes'
short compteur_bords = 0;	//	Compteur pour gnrer les bords
short y_vscreen = 0;	// Sert pour scroller l'cran (donc seulement sur TI89)
short y_menu = 0;	// Ordonne du curseur pour slectionner dans le menu
short last_animspe = 0;	//	Indice de la dernire animation spciale
short x_mur = 0;
short y_mur_haut = 0;
short y_mur_bas = 0;
short flag_mur = 0;	//	Dtermine l'existence d'un mur
short liste_flag_trompe[NB_MAX_TROMPES] = {};
short liste_x_trompe[NB_MAX_TROMPES] = {};
short liste_y_trompe[NB_MAX_TROMPES] = {};
short liste_dead_trompe[NB_MAX_TROMPES] = {};
short last_trompe = 0;	//	Indice de la dernire trompe
short vie = 0;
unsigned long score = 0;
short rapid_fire_unit = 0;	// Flag qui indique si le mode AUTO_FIRE est actif
short flag_touche_fire = 0;	// Evite la rptition de touche quand AUTO_FIRE est inactif
short x_bonus = 0;					//	Coordonnes
short y_bonus = 0;					//	du bonus courant
short flag_bonus = 0;				//	Indique l'existence d'un bonus et s'il existe, numro du bonus
short morts = 0;	// Comptabilise le nombre de morts pour envoyer les bonus appropris (seulement les animations normales)
short indice_vaisseau = 0;	// Indice du vaisseau courant dans les matrices de sprites
short aleat = 0;	// Nombre alatoire pour les bonus
short taille_canon = 0;	// Simple ou double ou triple canon
short tempo_tir = 0;	// Frquence de tir lorsqu'on a le rapid fire unit
short vaisseau_speed = 0;
short mode = 0;
short lives = 3;
short TEMPO_OEIL = 0;
short shield = 0;
						 
//==========================================================================//
//	Redirige les interruptions 1, 2 et 5 vers rien et active les niveaux de
//	gris
//==========================================================================//
 																			
void RedirigeInterruptions(void)
{
	randomize();
	
	int1 = GetIntVec(AUTO_INT_1);
	int2 = GetIntVec(AUTO_INT_2);
	int5 = GetIntVec(AUTO_INT_5);
	
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec(AUTO_INT_2, DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER);

	GrayOn();
}

//==========================================================================//
//	Restaure les interruptions, dsactive les niveaux de gris et redmarre
//	le timer de l'APD
//==========================================================================//

void RestaureInterruptions(void)
{		
	GrayOff();
	
	SetIntVec(AUTO_INT_1, int1);
	SetIntVec(AUTO_INT_2, int2);
	SetIntVec(AUTO_INT_5, int5);
	
	OSTimerRestart(APD_TIMER);
}

//==========================================================================//

#endif